(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('ng-input-price-format', ['exports', '@angular/core', '@angular/common', '@angular/forms'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ng-input-price-format'] = {}, global.ng.core, global.ng.common, global.ng.forms));
}(this, (function (exports, core, common, forms) { 'use strict';

    var InputPriceDirective = /** @class */ (function () {
        function InputPriceDirective(_DecimalPipe, _el, ngControl) {
            this._DecimalPipe = _DecimalPipe;
            this._el = _el;
            this.ngControl = ngControl;
            this.isEleFocus = false;
            _el.nativeElement.style.textAlign = 'right';
            _el.nativeElement.style.paddingRight = '4px';
        }
        InputPriceDirective.prototype.ngOnInit = function () {
            var _this = this;
            // This for initial: init form before pathchValue
            if (this.ngControl && this.ngControl.control) {
                this.ngControl.control.valueChanges.subscribe(function (e) {
                    if (!_this.isEleFocus) {
                        var map = _this._el.nativeElement.value;
                        if (typeof map === 'string') {
                            map = +(_this._el.nativeElement.value.replace(/,/g, ''));
                        }
                        if (map) {
                            _this._el.nativeElement.value = (_this._DecimalPipe.transform(map, '1.2-2'));
                        }
                    }
                });
            }
            // This for initial: pathchValue before init form
            if (this.ngControl && this.ngControl.value) {
                var map = this.ngControl.value;
                if (typeof map === 'string') {
                    map = +(this._el.nativeElement.value.replace(/,/g, ''));
                }
                if (map) {
                    this._el.nativeElement.value = (this._DecimalPipe.transform(map, '1.2-2'));
                }
            }
        };
        InputPriceDirective.prototype.onInput = function (value) {
            if (this._el.nativeElement.value != null) {
                var re = /[^0-9.]/g;
                re.test(this._el.nativeElement.value);
                // this.ctrl.setValue(this._el.nativeElement.value.replace(re, ''));
                this._el.nativeElement.value = this._el.nativeElement.value.replace(re, '');
            }
        };
        InputPriceDirective.prototype.onFocus = function () {
            this.isEleFocus = true;
            if (this._el.nativeElement.value != null) {
                if (typeof this._el.nativeElement.value === 'string') {
                    this._el.nativeElement.value = this._el.nativeElement.value.replace(/,/g, '');
                }
                if (typeof this._el.nativeElement.value === 'number') {
                    this._el.nativeElement.value = this._DecimalPipe.transform(this._el.nativeElement.value, '1.2-2');
                }
            }
        };
        InputPriceDirective.prototype.onBlur = function () {
            this.isEleFocus = false;
            if (this._el.nativeElement.value) {
                if (typeof this._el.nativeElement.value === 'string') {
                    this.ngControl.control.setValue(+(this._el.nativeElement.value.replace(/,/g, '')));
                    // this._el.nativeElement.value = +(this._el.nativeElement.value.replace(/,/g, ''));
                    this._el.nativeElement.value = (this._DecimalPipe.transform(+(this._el.nativeElement.value.replace(/,/g, '')), '1.2-2'));
                }
                else {
                    this._el.nativeElement.value = (this._DecimalPipe.transform(this._el.nativeElement.value, '1.2-2'));
                }
            }
        };
        return InputPriceDirective;
    }());
    InputPriceDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[inputPrice]'
                },] }
    ];
    InputPriceDirective.ctorParameters = function () { return [
        { type: common.DecimalPipe },
        { type: core.ElementRef },
        { type: forms.NgControl }
    ]; };
    InputPriceDirective.propDecorators = {
        onInput: [{ type: core.HostListener, args: ["input", ["$event.target.value"],] }],
        onFocus: [{ type: core.HostListener, args: ["focus",] }],
        onBlur: [{ type: core.HostListener, args: ["blur",] }]
    };

    var InputPriceLibModule = /** @class */ (function () {
        function InputPriceLibModule() {
        }
        return InputPriceLibModule;
    }());
    InputPriceLibModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        // InputPriceLibComponent,
                        InputPriceDirective
                    ],
                    imports: [],
                    exports: [
                        // InputPriceLibComponent,
                        InputPriceDirective
                    ],
                    providers: [
                        common.DecimalPipe
                    ]
                },] }
    ];

    /*
     * Public API Surface of input-price-lib
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.InputPriceDirective = InputPriceDirective;
    exports.InputPriceLibModule = InputPriceLibModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-input-price-format.umd.js.map
